program BeepServ;

uses
  Windows,
  SysUtils,
  uService;

{$APPTYPE CONSOLE}

type
  TBeepService = class(TService)
  protected
    procedure RunService; override;
  end;

procedure TBeepService.RunService;
begin
  while not WaitForStop(5*1000) do
    MessageBeep(MB_OK);
end;

var
  SuccessStatus: integer;
  Service: TService = nil;

begin
  IsMultiThread:=True;
  Service:=TBeepService.Create('BEEPSERV','Beep service');
  if FindCmdLineSwitch('INSTALL',['/','-'],True) then begin
    SuccessStatus:=Service.Install(stAuto,True);
    if SuccessStatus<>0 then begin
      WriteLn('Service install error ('+IntToStr(SuccessStatus)+')');
      WriteLn(GetLastErrorText);
    end
    else begin
      WriteLn('Service installed.');
    end;
    Halt;
  end;
  if FindCmdLineSwitch('UNINSTALL',['/','-'],True) then begin
    SuccessStatus:=Service.UnInstall(DefStopCallbackFunc,nil);
    if SuccessStatus<>0 then begin
      WriteLn('Service uninstall error ('+IntToStr(SuccessStatus)+')');
      WriteLn(GetLastErrorText);
    end
    else begin
      WriteLn('Service removed.');
    end;
    Halt;
  end;
  if FindCmdLineSwitch('?',['/','-'],True) or FindCmdLineSwitch('HELP',['/','-'],True)  then begin
    Writeln('----------------------------------------');
    Writeln('BeepServ usage help');
    Writeln('----------------------------------------');
    Writeln('BeepServ /install   : install service');
    Writeln('BeepServ /uninstall : uninstall service');
    Writeln('BeepServ /?         : this help');
    Halt;
  end;
  Service.Run;
end.