program SimpleEchoPipeServ;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  uThreadPool in 'uThreadPool.pas',
  uService in 'uService.pas',
  uSimpleEchoPipe in 'uSimpleEchoPipe.pas';

var
  SuccessStatus: integer;
  Service: TService = nil;

procedure MyExceptHandler(ExceptObject: TObject; ExceptAddr: Pointer);
var
  Buffer: array[0..1023] of char;
begin
  ExceptionErrorMessage(ExceptObject,ExceptAddr,Buffer,sizeof(Buffer));
  Service.AddToMessageLog(Buffer,EVENTLOG_ERROR_TYPE,0,0);
  Halt(1);
end;

begin
  IsMultiThread:=True;
  Service:=TSimpleEchoPipeService.Create('ECHOPIPESERV','Simple echo pipe service');
  if FindCmdLineSwitch('INSTALL',['/','-'],True) then begin
    SuccessStatus:=Service.Install(stAuto,True);
    if SuccessStatus<>0 then begin
      WriteLn('Service install error ('+IntToStr(SuccessStatus)+')');
      WriteLn(GetLastErrorText);
    end
    else begin
      WriteLn('Service installed.');
    end;
    Halt;
  end;
  if FindCmdLineSwitch('UNINSTALL',['/','-'],True) then begin
    SuccessStatus:=Service.UnInstall(DefStopCallbackFunc,nil);
    if SuccessStatus<>0 then begin
      WriteLn('Service uninstall error ('+IntToStr(SuccessStatus)+')');
      WriteLn(GetLastErrorText);
    end
    else begin
      WriteLn('Service removed.');
    end;
    Halt;
  end;
  if FindCmdLineSwitch('?',['/','-'],True) or FindCmdLineSwitch('HELP',['/','-'],True)  then begin
    Writeln('----------------------------------------');
    Writeln('SimpleEchoPipeServ usage help');
    Writeln('----------------------------------------');
    Writeln('SimpleEchoPipeServ /install   : install service');
    Writeln('SimpleEchoPipeServ /uninstall : uninstall service');
    Writeln('SimpleEchoPipeServ /?         : this help');
    Halt;
  end;
  ExceptProc:=@MyExceptHandler;
  Service.Run;
end.
